package jeuDeLavie;
public class Cellule {
    private static final char ACTIVE_CHAR = '*';

    private static final char INACTIVE_CHAR = '.';

    private static final java.awt.Color ACTIVE_COLOR = java.awt.Color.blue;

    private static final java.awt.Color INACTIVE_COLOR = java.awt.Color.white;

    private boolean etat;

    /**
     * Cration d'une cellule vide
     */
    public Cellule() {
        this(false);
    }

    /**
     * Cration d'une cellule
     * 
     * @param naissance
     *           fixe si la cellule est en vie ou non
     */
    public Cellule(boolean naissance) {
        setEtat(naissance);
    }

    /**
     * @return la couleur de la cellule
     */
    public java.awt.Color getCouleur() {
        return etat ? ACTIVE_COLOR : INACTIVE_COLOR;
    }

    public char getCar() {
        return etat ? ACTIVE_CHAR : INACTIVE_CHAR;
    }

    public void setEtat(boolean e) {
        etat = e;
    }

    public boolean getEtat() {
        return etat;
    }
    
    }
