package jeuDeLavie;

import java.awt.Color;

public class Environnement implements Grille {
    private int nbLignes;
    private int nbColonnes;
    private AfficheGrille afficheur;
    private Cellule[][] grilleCellules;
    
    public Environnement() {
       this(20,20);
    }
    
    public Environnement(int lignes, int colonnes) {
        this(lignes, colonnes, new AfficheurGrilleTexte());
    }
    
    public Environnement(int lignes, int colonnes, AfficheGrille display) {
        nbLignes = lignes;
        nbColonnes = colonnes;
        grilleCellules = new Cellule[lignes][colonnes];
        for(int i = 0; i < lignes; i++)
            for(int j = 0; j < colonnes; j++)
                grilleCellules[i][j] = new Cellule();
        setAfficheGrille(display);
    }

    public void setAfficheGrille(AfficheGrille d) {
        afficheur = d;
    }
    
    public int getNbColonnes() {
        return nbColonnes;
    }

    public int getNbLignes() {
        return nbLignes;
    }

    public Color getCouleurEn(Position p) {
        return grilleCellules[p.getLigne()][p.getColonne()].getCouleur();
    }

    public char getCaractereEn(Position p) {        
        return grilleCellules[p.getLigne()][p.getColonne()].getCar();
    }

    public Cellule getCelluleEn(Position p)
    {
        return grilleCellules[p.getLigne()][p.getColonne()];
    }
    
    public void setCelluleEn(Position p, boolean etat)
    {
        grilleCellules[p.getLigne()][p.getColonne()].setEtat(etat);
    }
    
    private int calculPos(int z, int max)
    {
     if (z == -1)  
         return max - 1;
     else if (z == max)
         	return 0;
     else return z;
    }
    
    public int nombreDeVoisins(Position p)
    {
        int nb = 0;
        int x = p.getLigne();
        int y = p.getColonne();
           
        for(int l = -1; l < 2; l++)
            for(int c = -1; c < 2; c++)
                if (grilleCellules[calculPos(x + l, nbLignes)][calculPos(y + c, nbColonnes)].getEtat()) nb++;
                return grilleCellules[x][y].getEtat() ? --nb : nb;
   }
}
