package jeuDeLavie;

public class Position {
    /**
     * Position dans la grille
     */

    private int ligne;

    private int colonne;

    /**
     * 
     * @param x
     *           ligne
     * @param y
     *           colonne
     */
    public Position(int x, int y) {
        ligne = x;
        colonne = y;
    }

    public int getLigne() {
        return ligne;
    }

    public int getColonne() {
        return colonne;
    }

    public boolean equals(Position p) {
        return (ligne == p.getLigne()) && (colonne == p.getColonne());
    }

    public boolean equals(Object o) {
        if (o instanceof Position) {
            return equals((Position) o);
        } else {
            throw new ClassCastException(o + " doit tre une position !");
        }
    }

    public String toString() {
        return "(" + ligne + "," + colonne + ")";
    }

    /**
     * 
     * @return un des 8 voisins de la position en considrant la grille comme un
     *         tore
     * @param nbLigne
     *           nombre de colonnes
     * @param nbColonne
     *           nombre de lignes
     */
    public Position voisinAleatoire(int nbLigne, int nbColonne) {
        int dx = 0;
        int dy = 0;
        do {
            dx = (((int) (Math.random() * 1000)) % 3) - 1;
            dy = (((int) (Math.random() * 1000)) % 3) - 1;
        } while (dx == 0 && dy == 0);
        return new Position((nbLigne + ligne + dx) % nbLigne, (nbColonne
                + colonne + dy)
                % nbColonne);
    }

}
